import type { OperationType } from "./types";
export declare class PublicError extends Error {
    readonly cause: unknown;
    constructor(message?: string, cause?: unknown);
    static isPublicError: (error: unknown) => boolean;
}
export declare class OperationExecutionError extends Error {
    readonly cause: unknown;
    readonly simpleMessage: string;
    readonly operationType: OperationType<unknown, unknown>;
    readonly operation: unknown;
    readonly context: unknown;
    constructor(operation: unknown, context: unknown, operationType: OperationType<unknown, unknown>, message?: string, cause?: unknown);
    sameContent(operation: unknown, context: unknown, operationType: OperationType<unknown, unknown>): boolean;
    static stringifyContext: (context: unknown, operationType: OperationType<unknown, unknown>) => string;
    static stringifyOperation: (operation: unknown, operationType: OperationType<unknown, unknown>) => string;
    static createErrorMessage: typeof _createOperationExecutionErrorMessage;
}
declare function _createOperationExecutionErrorMessage(operation: unknown, context: unknown, operationType: OperationType<unknown, unknown>, message?: string, cause?: unknown): string;
export {};
