import type { Executor, OperationType } from "./types";
export declare function combineExecutors<Context>(...executors: Array<Executor<Context>>): Executor<Context>;
export declare function filterImplementationsByOperationType<Context>(executor: Executor<Context>, filter: (operationType: OperationType<unknown, unknown>) => boolean): Executor<Context>;
export declare function interceptAnyOperation<Context>(executor: Executor<Context>, interceptor: (operation: unknown, context: Context, operationType: OperationType<unknown, unknown>, next: Executor<Context>) => Promise<unknown>): Executor<Context>;
export declare function hasOperationImplementation(executor: Executor<any>, operationType: OperationType<unknown, unknown>): boolean;
export declare function getImplementedOperations(executor: Executor<any>): OperationType<unknown, unknown>[];
export declare function getImplementedOperationByName(executor: Executor<any>, operationName: string): OperationType<unknown, unknown> | undefined;
