import type { Executor, OperationArgumentType, OperationResultType, OperationType } from "./types";
export declare type _ImplementedOperations = {
    [operationName: string]: _ExecutorPrivate<any>;
};
export declare type _ImplementedOperationTypes = {
    [operationName: string]: OperationType<any, any>;
};
export declare function _asExecutorPrivate<Context>(executor: Executor<Context>): _ExecutorPrivate<Context>;
export interface _ExecutorPrivate<Context> extends Executor<Context> {
    <Op, Result, Type extends OperationType<Op, Result>>(operation: Op, context: Context, operationType: Type): Promise<Result>;
    _implementedOperations: _ImplementedOperations;
    _implementedOperationTypes: _ImplementedOperationTypes;
}
export declare function _implementExecutor<Type extends OperationType<any, any>, Context>(operationType: Type, executor: (operation: OperationArgumentType<Type>, context: Context, operationType: Type) => Promise<OperationResultType<Type>>): _ExecutorPrivate<Context>;
export declare function _implementCombinedExecutor<Context>(implementedOperations: _ImplementedOperations, implementedOperationTypes: _ImplementedOperationTypes): _ExecutorPrivate<Context>;
export declare function _implementInterceptor<Context>(operationType: OperationType<any, any>, impl: _ExecutorPrivate<Context>, interceptor: (operation: unknown, context: Context, operationType: OperationType<unknown, unknown>, next: Executor<Context>) => Promise<unknown>): _ExecutorPrivate<Context>;
