import { _ImplementedOperationTypes } from "./implementation";
declare const _operationType: unique symbol;
declare const _resultType: unique symbol;
declare const _type: unique symbol;
declare const _executorContext: unique symbol;
export interface Executor<Context> {
    readonly [_type]: 'Executor';
    readonly [_executorContext]: (context: Context) => void;
}
export declare class OperationType<Op, Result> {
    readonly name: string;
    readonly [_operationType]: Op;
    readonly [_resultType]: Result;
    readonly [_type]: 'OperationType';
    constructor(name: string);
    implementAs<Context>(executor: (operation: Op, context: Context, operationType: this) => Promise<Result>): Executor<Context>;
    execute<ExecutorContext, Context extends ExecutorContext>(operation: Op, context: Context, executor: Executor<ExecutorContext>): Promise<Result>;
    execute(operation: Op, fn: (operation: Op, operationType: this) => Promise<Result>): Promise<Result>;
}
export declare type ExecutorContextType<ExecutorType extends Executor<any>> = ExecutorType extends Executor<infer context> ? context : never;
export declare type OperationArgumentType<Type extends OperationType<any, any>> = Type[typeof _operationType];
export declare type OperationResultType<Type extends OperationType<any, any>> = Type[typeof _resultType];
export declare const _knownOperations: _ImplementedOperationTypes;
export {};
