"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._knownOperations = exports.OperationType = void 0;
const implementation_1 = require("./implementation");
const _operationType = Symbol('operationType');
const _resultType = Symbol('resultType');
const _type = Symbol('type');
const _executorContext = Symbol('executorPrivate');
class OperationType {
    constructor(name) {
        this.name = name;
        if (name in exports._knownOperations) {
            throw new Error('Another operation with name "' + name + '" already exists');
        }
        exports._knownOperations[name] = this;
    }
    implementAs(executor) {
        return implementation_1._implementExecutor(this, executor);
    }
    execute(operation, context, executor) {
        if (!executor) {
            const fn = context;
            return fn(operation, this);
        }
        return implementation_1._asExecutorPrivate(executor)(operation, context, this);
    }
}
exports.OperationType = OperationType;
exports._knownOperations = {};
